Index: /java/main/src/main/java/com/framsticks/params/SimpleAbstractAccess.java
===================================================================
--- /java/main/src/main/java/com/framsticks/params/SimpleAbstractAccess.java	(revision 77)
+++ /java/main/src/main/java/com/framsticks/params/SimpleAbstractAccess.java	(revision 78)
@@ -38,17 +38,13 @@
 		this.framsClass = framsClass;
 	}
-
-
-
-
     /**
 	 * Simple String key, value class.
 	 */
-	private static class Entry {
-
-		String key;
-		String value;
-
-		Entry(String key, String value) {
+	public static class Entry {
+
+		public final String key;
+		public final String value;
+
+		public Entry(String key, String value) {
 			this.key = key;
 			this.value = value;
@@ -331,5 +327,4 @@
 
         Entry entry;
-
         while ((entry = readEntry(source)) != null) {
             Param param = getParam(entry.key);
@@ -351,138 +346,6 @@
     }
 
-    @Override
-	public List<Exception> load2(String line) throws Exception {
-		this.clearValues();
-
-		// list of not terminable exceptions that occured
-		List<Exception> exceptions = new ArrayList<Exception>();
-
-		int indexOfColon = line.indexOf(':');
-		if (indexOfColon < 0)
-			indexOfColon = line.length();
-		String classId = line.substring(0, indexOfColon).trim();
-		if (!getId().equals(classId))
-			throw new Exception(
-					"Inappropriate getId of param interface (class), specified \""
-							+ classId + "\" while should be \"" + getId()
-							+ "\"");
-		String parameters;
-		if (indexOfColon == line.length())
-			parameters = "";
-		else
-			parameters = line.substring(indexOfColon + 1);
-
-		// tokenize
-		boolean doubleQuotes = false;
-		char previousChar = ',';
-		List<Entry> result = new ArrayList<Entry>();
-		StringBuilder stringBuilder = new StringBuilder();
-		String key = "";
-		if (parameters.trim().length() > 0) {
-			for (char currentChar : parameters.toCharArray()) {
-				if (!doubleQuotes && currentChar == '=' && "".equals(key)) {
-					key = stringBuilder.toString();
-					stringBuilder = new StringBuilder();
-				} else if (!doubleQuotes && currentChar == ',') {
-					if (previousChar == ',') {
-						result.add(new Entry(key.trim(), null));
-					} else {
-						result.add(new Entry(key.trim(), stringBuilder
-								.toString().trim()));
-					}
-					stringBuilder = new StringBuilder();
-					key = "";
-				} else if (currentChar == '"') {
-					if (previousChar == '\\') {
-						stringBuilder.deleteCharAt(stringBuilder.length() - 1);
-						stringBuilder.append(currentChar);
-					} else
-						doubleQuotes = !doubleQuotes;
-				} else {
-					stringBuilder.append(currentChar);
-				}
-
-				previousChar = currentChar;
-			}
-
-			String last = stringBuilder.toString().trim();
-			// if (last.length() > 0 || previousChar == '\"'
-			// || previousChar == ':')
-			result.add(new Entry(key.trim(), last));
-
-			if (doubleQuotes)
-				throw new Exception(
-						"Double quotes expected while end of line met");
-		}
-
-		// if successfully parsed set all necessary values
-
-		//TODO: name omitting
-		Param currentParam = null;
-		boolean illegallyOmittedName = false;
-		for (Entry pair : result) {
-			try {
-
-				if (pair.key != null && !"".equals(pair.key)) {
-					Param param = getParam(pair.key);
-					if (param == null) {
-						illegallyOmittedName = true;
-						throw new Exception("No parameter with such id: "
-								+ pair.key);
-					} else {
-						currentParam = param;
-						illegallyOmittedName = false;
-					}
-				} else if (illegallyOmittedName
-						|| (currentParam.getFlags() & Flags.CANOMITNAME) == 0) {
-					throw new Exception(
-							"Parameter with offset: "
-									+ currentParam
-									+ " is not set, "
-									+ "because it's definition or definition of one of the previous params "
-									+ "does not contain flag, which allow to skip the getName (flag 1024)");
-				}
-
-				if (pair.value != null) {
-					int setFlag = this.set(currentParam, pair.value);
-					if ((setFlag & Flags.PSET_HITMIN) != 0) {
-						exceptions.add(createBoundaryHitException(currentParam, pair.value, Flags.PSET_HITMIN));
-					}
-
-					if ((setFlag & Flags.PSET_HITMAX) != 0) {
-						exceptions.add(createBoundaryHitException(currentParam, pair.value, Flags.PSET_HITMAX));
-					}
-
-					if ((setFlag & Flags.PSET_RONLY) != 0) {
-						throw (new Exception(
-								"Tried to set a read-only attribute \""
-										+ currentParam.getId()
-										+ "\" in class \"" + getId() + "\""));
-					}
-				}
-
-			} catch (Exception e) {
-				exceptions.add(e);
-			//} finally {
-			//  currentProperty++;
-			}
-		}
-		return exceptions;
-	}
-
-	private Exception createBoundaryHitException(Param param, String value, int flag) {
-		boolean minimum = (flag & Flags.PSET_HITMIN) != 0;
-		String boundary = (minimum ? param.getMin(Object.class) : param.getMax(Object.class)).toString();
-		String name =  (minimum ? "minimum" : "maximum");
-		return new Exception("Tried to set attribute \""
-				+ param.getId()
-				+ "\" in class \""
-				+ getId()
-				+ "\" to value which exceeds " + name + " ("
-				+ value
-				+ "), truncated to: "
-				+ boundary);
-	}
-	
+
+
 	protected abstract <T> void internalSet(Param param, T value);
 
Index: /java/main/src/main/java/com/framsticks/params/Util.java
===================================================================
--- /java/main/src/main/java/com/framsticks/params/Util.java	(revision 77)
+++ /java/main/src/main/java/com/framsticks/params/Util.java	(revision 78)
@@ -1,3 +1,6 @@
 package com.framsticks.params;
+
+import java.util.ArrayList;
+import java.util.List;
 
 /**
@@ -14,3 +17,25 @@
         return result.toString();
     }
+	public static List<Object> stripAccessInterface(List<AccessInterface> accesses) {
+		List<Object> result = new ArrayList<Object>();
+		for (AccessInterface a : accesses) {
+			result.add(a.getSelected());
+		}
+		return result;
+	}
+	public static int copyParams(AccessInterface to, AccessInterface from) {
+		int copied = 0;
+		for (Param f : from.getParams()) {
+			Param t = from.getParam(f.getId());
+			if (t == null) {
+				continue;
+			}
+			if (to.getClass() != f.getClass()) {
+				continue;
+			}
+			to.set(t, from.get(f, Object.class));
+			++copied;
+		}
+		return copied;
+	}
 }
Index: /java/main/src/main/java/com/framsticks/parsers/F0Parser.java
===================================================================
--- /java/main/src/main/java/com/framsticks/parsers/F0Parser.java	(revision 78)
+++ /java/main/src/main/java/com/framsticks/parsers/F0Parser.java	(revision 78)
@@ -0,0 +1,258 @@
+package com.framsticks.parsers;
+
+import java.io.BufferedReader;
+import java.io.IOException;
+import java.io.InputStream;
+import java.io.InputStreamReader;
+import java.text.ParseException;
+import java.util.ArrayList;
+import java.util.List;
+
+import com.framsticks.model.F0Genotype;
+import static com.framsticks.params.SimpleAbstractAccess.*;
+
+import com.framsticks.params.Flags;
+import com.framsticks.params.Param;
+import com.framsticks.util.Exceptions;
+import com.framsticks.util.Pair;
+import com.framsticks.util.Strings;
+import org.apache.log4j.Logger;
+
+import com.framsticks.params.FramsClass;
+import com.framsticks.params.AccessInterface;
+
+/**
+ * The class Parser is used to parse genotype encoded in f0 representation.
+ */
+public class F0Parser {
+
+	private final static Logger LOGGER = Logger.getLogger(F0Parser.class);
+
+	/** The schema proper for f0 representation. */
+	protected final Schema schema;
+	protected final InputStream is;
+	protected final List<AccessInterface> result = new ArrayList<AccessInterface>();
+	int lineNumber = 0;
+
+	public F0Parser(Schema schema, InputStream is) {
+		assert schema != null;
+		assert is != null;
+		this.schema = schema;
+		this.is = is;
+	}
+
+	protected AccessInterface processLine(String line) {
+		try {
+
+			Pair<String, String> p = Strings.splitIntoPair(line, ':', "");
+			String classId = p.first.trim();
+			FramsClass framsClass = schema.getRegistry().getInfoFromCache(classId);
+			if (framsClass == null) {
+				throw new Exception("unknown class id: " + classId);
+			}
+			AccessInterface access = schema.getRegistry().createAccess(classId, framsClass);
+			access.select(access.createAccessee());
+			for (Exception e : loadFromLine(access, p.second)) {
+				warn(lineNumber, "however entry was added", e);
+			}
+			return access;
+		} catch (Exception e) {
+			warn(lineNumber, "entry was not added", e);
+		}
+		return null;
+	}
+
+	/**
+	 * Parses the stream with genotype in f0 representation. The correctness of
+	 * genotype is checked. IO and syntax exceptions interrupts parsing and no
+	 * result is returned. Other exceptions, connected with schema validation
+	 * cause that certain object or it's parameter is ignored (appropriate
+	 * communicate informs user about it). Inappropriate values in numeric
+	 * fields (bigger than maximum or smaller than minimum values) are
+	 * communicated by warnings and set to minimum / maximum value.
+	 * 
+	 * @return the list
+	 * @throws IOException
+	 *             Signals that an I/O exception has occurred.
+	 * @throws ParseException
+	 *             the parse exception
+	 */
+	public List<AccessInterface> parse() throws IOException,
+			ParseException {
+
+		InputStreamReader reader = null;
+		try {
+			reader = new InputStreamReader(is, "UTF-8");
+			BufferedReader br = new BufferedReader(reader);
+			while (br.ready()) {
+				++lineNumber;
+				String line = br.readLine();
+				line = (line == null ? "" : line.trim());
+				if (lineNumber == 1) {
+					if (!"//0".equals(line)) {
+						LOGGER.warn("stream should begin with \"//0\" in the first line");
+					} else {
+						continue;
+					}
+				}
+				if (line.equals("")) {
+					continue;
+				}
+				if (line.startsWith("#")) {
+					continue;
+				}
+				AccessInterface access = processLine(line);
+				if (access != null) {
+					result.add(access);
+				}
+			}
+
+			/** If no 'm' (Model) line was found, than simulate it on the beginning of the result.*/
+			if (result.isEmpty() || !(result.get(0) instanceof F0Genotype)) {
+				result.add(0, processLine("m:"));
+			}
+		} finally {
+			if (reader != null) {
+				reader.close();
+			}
+		}
+
+		return result;
+	}
+
+	private static void warn(int lineNumber, String message, Exception e) {
+		LOGGER.warn("in line " + lineNumber + " the following error occurred (" + message + "): " + e + "\n" + Exceptions.printStackTrace(e));
+	}
+
+	/** Breaks string into entries.*/
+	public List<Entry> breakIntoEntries(String parameters) throws Exception {
+		// tokenize
+		boolean inQuotes = false;
+		char previousChar = ',';
+		List<Entry> result = new ArrayList<Entry>();
+		StringBuilder stringBuilder = new StringBuilder();
+		String key = null;
+		if (parameters.trim().length() > 0) {
+			for (char currentChar : parameters.toCharArray()) {
+				if (!inQuotes && (currentChar == '=') && (key == null)) {
+					key = stringBuilder.toString().trim();
+					stringBuilder = new StringBuilder();
+				} else if (!inQuotes && currentChar == ',') {
+					if (previousChar == ',') {
+						result.add(new Entry(key, null));
+					} else {
+						result.add(new Entry(key, stringBuilder.toString().trim()));
+					}
+					stringBuilder = new StringBuilder();
+					key = null;
+				} else if (currentChar == '"') {
+					if (previousChar == '\\') {
+						stringBuilder.deleteCharAt(stringBuilder.length() - 1);
+						stringBuilder.append(currentChar);
+					} else {
+						inQuotes = !inQuotes;
+					}
+				} else {
+					stringBuilder.append(currentChar);
+				}
+
+				previousChar = currentChar;
+			}
+
+			result.add(new Entry(key, stringBuilder.toString().trim()));
+
+			if (inQuotes) {
+				throw new Exception("Double quotes expected while end of line met");
+			}
+		}
+		return result;
+	}
+
+	public List<Exception> loadFromLine(AccessInterface access, String parameters) throws Exception {
+
+		List<Entry> entries = breakIntoEntries(parameters);
+
+		List<Exception> exceptions = new ArrayList<Exception>();
+
+		Param[] params = access.getParams().toArray(new Param[] {null});
+		if (params.length == 0) {
+			return exceptions;
+		}
+		for (Param p : params) {
+			Object def = p.getDef(Object.class);
+			if (def != null) {
+				access.set(p, def);
+			}
+		}
+
+		int number = -1;
+		Integer nextParamNumber = 0;
+		for (Entry pair : entries) {
+			++number;
+			try {
+				Param currentParam;
+				if (pair.key != null) {
+					currentParam = access.getParam(pair.key);
+					if (currentParam == null) {
+						nextParamNumber = null;
+						throw new Exception("no parameter with such id: " + pair.key);
+					}
+				} else {
+					if (nextParamNumber == null || ((params[nextParamNumber].getFlags() & Flags.CANOMITNAME) == 0)) {
+						nextParamNumber = null;
+						throw new Exception(
+								"parameter with offset: "
+										+ number
+										+ " is not set, "
+										+ "because it's definition or definition of the previous param "
+										+ "does not contain flag, which allows to skip the name (flag 1024)");
+					}
+					currentParam = params[nextParamNumber];
+				}
+
+				if (currentParam != null) {
+					if (pair.value != null) {
+						int setFlag = access.set(currentParam, pair.value);
+						if ((setFlag & Flags.PSET_HITMIN) != 0) {
+							exceptions.add(createBoundaryHitException(access, currentParam, pair.value, Flags.PSET_HITMIN));
+						}
+
+						if ((setFlag & Flags.PSET_HITMAX) != 0) {
+							exceptions.add(createBoundaryHitException(access, currentParam, pair.value, Flags.PSET_HITMAX));
+						}
+
+						if ((setFlag & Flags.PSET_RONLY) != 0) {
+							throw (new Exception("tried to set a read-only attribute \""
+								+ currentParam.getId()
+								+ "\" in class \"" + access.getId() + "\""));
+						}
+					}
+					nextParamNumber = null;
+					for (int j = params.length - 1; j > 0; --j) {
+						if (params[j - 1] == currentParam) {
+							nextParamNumber = j;
+						}
+					}
+				}
+
+			} catch (Exception e) {
+				exceptions.add(e);
+			}
+		}
+		return exceptions;
+	}
+
+	private static Exception createBoundaryHitException(AccessInterface access, Param param, String value, int flag) {
+		boolean minimum = (flag & Flags.PSET_HITMIN) != 0;
+		String boundary = (minimum ? param.getMin(Object.class) : param.getMax(Object.class)).toString();
+		String name =  (minimum ? "minimum" : "maximum");
+		return new Exception("Tried to set attribute \""
+				+ param.getId()
+				+ "\" in class \""
+				+ access.getId()
+				+ "\" to value which exceeds " + name + " ("
+				+ value
+				+ "), truncated to: "
+				+ boundary);
+	}
+}
Index: /java/main/src/main/java/com/framsticks/parsers/FileSource.java
===================================================================
--- /java/main/src/main/java/com/framsticks/parsers/FileSource.java	(revision 77)
+++ /java/main/src/main/java/com/framsticks/parsers/FileSource.java	(revision 78)
@@ -3,7 +3,5 @@
 import com.framsticks.params.SourceInterface;
 
-import java.io.BufferedReader;
-import java.io.FileReader;
-import java.io.IOException;
+import java.io.*;
 
 
@@ -17,4 +15,9 @@
 		this.filename = filename;
         reader = new BufferedReader(new FileReader(filename));
+	}
+
+	public FileSource(InputStream stream) {
+		filename = "<stream>";
+		reader = new BufferedReader(new InputStreamReader(stream));
 	}
 
Index: /java/main/src/main/java/com/framsticks/parsers/Schema.java
===================================================================
--- /java/main/src/main/java/com/framsticks/parsers/Schema.java	(revision 77)
+++ /java/main/src/main/java/com/framsticks/parsers/Schema.java	(revision 78)
@@ -1,4 +1,6 @@
 package com.framsticks.parsers;
 
+import java.io.File;
+import java.io.FileInputStream;
 import java.io.IOException;
 import java.io.InputStream;
@@ -8,7 +10,7 @@
 import java.util.Map.Entry;
 
-import com.framsticks.params.FramsClass;
-import com.framsticks.params.Param;
+import com.framsticks.params.*;
 import com.framsticks.params.types.DecimalParam;
+import com.framsticks.params.types.FloatParam;
 import com.framsticks.params.types.StringParam;
 import org.apache.log4j.Logger;
@@ -19,6 +21,4 @@
 
 import com.framsticks.leftovers.f0.NeuroClass;
-import com.framsticks.params.Group;
-import com.framsticks.params.ParamBuilder;
 import org.w3c.dom.Document;
 import org.w3c.dom.NamedNodeMap;
@@ -39,21 +39,12 @@
 	private final static Logger logger = Logger.getLogger(Schema.class);
 
-	/** The main classes (such as part, joint, etc.) */
-	private Map<String, FramsClass> mainClasses = new HashMap<String, FramsClass>();
+	protected final Registry registry = new Registry();
 
 	/** The neuro classes (classess representing different types of neurons). */
 	private Map<String, NeuroClass> neuroClasses = new HashMap<String, NeuroClass>();
 
-	// TODO: definition can be changed
-	/**
-	 * Instantiates a new schema with usage of f0def.xml file stored in
-	 * resources.
-	 * 
-	 * @throws Exception
-	 *             the exception if one occured while reading the stream
-	 */
-	public Schema() throws Exception {
-		this(Thread.currentThread().getContextClassLoader()
-				.getResourceAsStream("f0def.xml"));
+	public static InputStream getDefaultDefinitionAsStream() {
+		//return new FileInputStream(new File(Schema.class.getResource("/parsers/f0def.xml").getPath()));
+		return Schema.class.getResourceAsStream("/parsers/f0def.xml");
 	}
 
@@ -61,10 +52,10 @@
 	 * Instantiates a new schema.
 	 * 
-	 * @param xmlStream
+	 * @param inputStream
 	 *            the xml stream with schema
 	 * @throws Exception
-	 *             the exception if one occured while reading the stream
-	 */
-	public Schema(InputStream xmlStream) throws Exception {
+	 *             the exception if one occurred while reading the stream
+	 */
+	public Schema(InputStream inputStream) throws Exception {
 
 		DocumentBuilderFactory factory;
@@ -75,5 +66,5 @@
 			db = factory.newDocumentBuilder();
 
-			Document document = db.parse(xmlStream);
+			Document document = db.parse(inputStream);
 			NodeList classes = document.getElementsByTagName("CLASS");
 
@@ -81,5 +72,5 @@
 				Node classNode = classes.item(i);
 				FramsClass framsClass = processClass(classNode);
-				mainClasses.put(framsClass.getId(), framsClass);
+				registry.putInfoIntoCache(framsClass);
 			}
 
@@ -106,5 +97,5 @@
 							symbolGlymph[j] = Integer.parseInt(sgha[j]);
 						} catch (NumberFormatException e) {
-							logger.error("an error occured while parsing symbol glymph, class getId: "
+							logger.error("an error occurred while parsing symbol glymph, class getId: "
 									+ framsClass.getId()
 									+ ", glymph offset: " + j);
@@ -119,11 +110,11 @@
 
 		} catch (IOException e) {
-			logger.fatal("unexpected exception occured: ", e);
+			logger.fatal("unexpected exception occurred: ", e);
 			throw e;
 		} catch (ParserConfigurationException e) {
-			logger.fatal("unexpected exception occured: ", e);
+			logger.fatal("unexpected exception occurred: ", e);
 			throw e;
 		} catch (SAXException e) {
-			logger.fatal("unexpected exception occured: ", e);
+			logger.fatal("unexpected exception occurred: ", e);
 			throw e;
 		}
@@ -140,11 +131,15 @@
 	 */
 	private static int getIntAttribute(NamedNodeMap attributes, String name) {
+		String v = getAttribute(attributes, name);
+		if (v == null) {
+			return 0;
+		}
 		try {
-			return Integer.parseInt(getAttribute(attributes, name));
+			return Integer.parseInt(v);
 		} catch (NullPointerException e) {
 			return 0;
 		} catch (NumberFormatException e) {
 			logger.fatal("attribute " + name
-					+ " should be numeric (it is not)");
+					+ " should be numeric: " + v);
 			return 0;
 		}
@@ -186,5 +181,5 @@
 	 *             the exception in case of any error
 	 */
-	private FramsClass processClass(Node classNode) throws Exception {
+	private static FramsClass processClass(Node classNode) throws Exception {
 		String classId = null;
 		String className = "";
@@ -200,6 +195,5 @@
 		classDescription = getAttributeFromNode("DESCRIPTION", classNode);
 
-		FramsClass framsClass = new FramsClass(classId, className,
-				classDescription);
+		FramsClass framsClass = new FramsClass(classId, className, classDescription);
 
 		NodeList classProperties = classNode.getChildNodes();
@@ -210,12 +204,11 @@
 			if ("GROUP".equals(node.getNodeName())) {
 				NamedNodeMap attributes = node.getAttributes();
-				String name = attributes.getNamedItem("NAME") == null ? null
-						: attributes.getNamedItem("NAME").getNodeValue();
-				if (name == null)
-					logger.warn("Group getName in class \"" + classId + "\" ("
+				String name = getAttribute(attributes, "NAME");
+				if (name == null) {
+					logger.warn("Group name in class \"" + classId + "\" ("
 							+ className + ") is undefined");
-				else
+				} else {
 					framsClass.appendGroup(new Group(name));
-
+				}
 			} else if ("PROP".equals(node.getNodeName())
 					|| "NEUROPROP".equals(node.getNodeName())) {
@@ -232,5 +225,5 @@
 
 	/**
-	 * It analyses the single property within the clas
+	 * It analyses the single property within the class
 	 * 
 	 * @param attributes
@@ -242,5 +235,5 @@
 	 *             the exception in case of any error
 	 */
-	private Param processParameter(NamedNodeMap attributes, String classId)
+	private static Param processParameter(NamedNodeMap attributes, String classId)
 			throws Exception {
 
@@ -315,5 +308,5 @@
 				}
 			}
-			builder.setType(DecimalParam.class);
+			builder.setType(FloatParam.class);
 			builder.setMin(minMaxDefDouble.get("MIN"));
 			builder.setMax(minMaxDefDouble.get("MAX"));
@@ -330,7 +323,4 @@
 	}
 
-	public Map<String, FramsClass> getMainClasses() {
-		return Collections.unmodifiableMap(mainClasses);
-	}
 
 	public Map<String, NeuroClass> getNeuroClasses() {
@@ -338,3 +328,8 @@
 	}
 
+	public final Registry getRegistry() {
+		return registry;
+	}
+
+
 }
Index: /java/main/src/main/java/com/framsticks/portals/Portal.java
===================================================================
--- /java/main/src/main/java/com/framsticks/portals/Portal.java	(revision 77)
+++ /java/main/src/main/java/com/framsticks/portals/Portal.java	(revision 78)
@@ -36,5 +36,5 @@
 
     @Override
-    protected void configure() {
+    protected void configure() throws Exception {
         super.configure();
     }
Index: /java/main/src/main/java/com/framsticks/util/Exceptions.java
===================================================================
--- /java/main/src/main/java/com/framsticks/util/Exceptions.java	(revision 78)
+++ /java/main/src/main/java/com/framsticks/util/Exceptions.java	(revision 78)
@@ -0,0 +1,15 @@
+package com.framsticks.util;
+
+import java.io.PrintWriter;
+import java.io.StringWriter;
+
+/**
+ * Author: Piotr Śniegowski
+ */
+public class Exceptions {
+	public static String printStackTrace(Throwable throwable) {
+		StringWriter w = new StringWriter();
+		throwable.printStackTrace(new PrintWriter(w));
+		return w.getBuffer().toString();
+	}
+}
Index: /java/main/src/main/java/com/framsticks/util/Orientation.java
===================================================================
--- /java/main/src/main/java/com/framsticks/util/Orientation.java	(revision 77)
+++ /java/main/src/main/java/com/framsticks/util/Orientation.java	(revision 78)
@@ -9,10 +9,71 @@
     public final Point3d z;
 
-    public Orientation() {
-        x = new Point3d();
-        y = new Point3d();
-        z = new Point3d();
-    }
+	public Orientation(Point3d x, Point3d y, Point3d z) {
+		this.x = x;
+		this.y = y;
+		this.z = z;
+	}
+
+	public Orientation() {
+		x = new Point3d(1, 0, 0);
+		y = new Point3d(0, 1, 0);
+		z = new Point3d(0, 0, 1);
+	}
+
+	/** based on c++ void Orient::transform(Pt3D& target,const Pt3D &s) const */
+	public Point3d transform(Point3d source) {
+		Point3d.Builder b = new Point3d.Builder();
+		for (int i = 0; i < 3; ++i) {
+			double v = 0;
+			for (int j = 0; j < 3; ++j) {
+				v += source.get(j) * this.get(j).get(i);
+			}
+			b.set(i, v);
+		}
+		return b.build();
+	}
+
+	/** based on c++ void Orient::transform(Orient& target,const Orient& src) const */
+	public Orientation transform(Orientation source) {
+		return new Orientation(transform(source.x), transform(source.y), transform(source.z));
+	}
+
+	protected static Point3d rotate2D(double sin, double cos, Point3d p, int a0, int a1, int im) {
+		Point3d.Builder b = new Point3d.Builder();
+		b.set(a0, cos * p.get(a0) - sin * p.get(a1));
+		b.set(a1, sin * p.get(a0) + cos * p.get(a1));
+		b.set(im, p.get(im));
+		return b.build();
+	}
+
+	/** based on c++ Orient::rotate(const Pt3D &v) */
+	public Orientation rotate(Point3d v) {
+		Point3d[] p = new Point3d[] {x, y, z};
+
+		for (int i = 0; i < 3; ++i) {
+			double sin = Math.sin(v.get(i));
+			double cos = Math.cos(v.get(i));
+
+			for (int j = 0; j < 3; ++j) {
+				p[j] = rotate2D(sin, cos, p[j], i == 0 ? 1 : 0, i == 2 ? 1 : 2, i);
+			}
+		}
+		return new Orientation(p[0], p[1], p[2]);
+	}
+
+	final Point3d get(int i) {
+		switch (i) {
+			case 0: return x;
+			case 1: return y;
+			case 2: return z;
+		}
+		assert false;
+		return null;
+	}
 
 
+	@Override
+	public final String toString() {
+		return x + " | " + y + " | " + z;
+	}
 }
Index: /java/main/src/main/java/com/framsticks/util/Point3d.java
===================================================================
--- /java/main/src/main/java/com/framsticks/util/Point3d.java	(revision 77)
+++ /java/main/src/main/java/com/framsticks/util/Point3d.java	(revision 78)
@@ -6,7 +6,7 @@
 public class Point3d
 {
-	public Double x;
-	public Double y;
-	public Double z;
+	public final double x;
+	public final double y;
+	public final double z;
 
 	public Point3d() {
@@ -16,5 +16,5 @@
 	}
 
-	public Point3d(Double x, Double y, Double z) {
+	public Point3d(double x, double y, double z) {
 		this.x = x;
 		this.y = y;
@@ -22,8 +22,46 @@
 	}
 
+	public Point3d(Point3d p) {
+		x = p.x;
+		y = p.y;
+		z = p.z;
+	}
+
 	@Override
-	public String toString() {
-		//return new StringBuilder().append(x).append(" ").append(y).append(" ").append("z").toString();
+	public final String toString() {
 		return x + " " + y + " " + z;
 	}
+
+	public final double get(int i) {
+		switch (i) {
+			case 0: return x;
+			case 1: return y;
+			case 2: return z;
+		}
+		assert false;
+		return 0;
+	}
+
+
+	public final Point3d add(Point3d p) {
+		return new Point3d(x + p.x, y + p.y, z + p.z);
+	}
+
+	public final Point3d sub(Point3d p) {
+		return new Point3d(x - p.x, y - p.y, z - p.z);
+	}
+
+	public final double length() {
+		return Math.sqrt(x * x + y * y + z * z);
+	}
+
+	public static class Builder {
+		double[] a = new double[3];
+
+		public Point3d build() { return new Point3d(a[0], a[1], a[2]); }
+
+		public final void set(int i, double v) {
+			a[i] = v;
+		}
+	}
 }
Index: /java/main/src/main/java/com/framsticks/viewer/SimpleViewer.java
===================================================================
--- /java/main/src/main/java/com/framsticks/viewer/SimpleViewer.java	(revision 78)
+++ /java/main/src/main/java/com/framsticks/viewer/SimpleViewer.java	(revision 78)
@@ -0,0 +1,14 @@
+package com.framsticks.viewer;
+
+import com.framsticks.core.Entity;
+import com.framsticks.core.Parameters;
+
+/**
+ * Author: Piotr Śniegowski
+ */
+public class SimpleViewer extends Entity {
+
+	public SimpleViewer(Parameters parameters) {
+		super(parameters);
+	}
+}
Index: /java/main/src/main/java/com/framsticks/visualization/Viewer.java
===================================================================
--- /java/main/src/main/java/com/framsticks/visualization/Viewer.java	(revision 77)
+++ /java/main/src/main/java/com/framsticks/visualization/Viewer.java	(revision 78)
@@ -1,5 +1,4 @@
 package com.framsticks.visualization;
 
-import com.framsticks.communication.Connection;
 import com.framsticks.model.World;
 import com.sun.j3d.loaders.IncorrectFormatException;
@@ -22,14 +21,10 @@
 import java.awt.event.ActionListener;
 import java.io.FileNotFoundException;
-import java.util.ArrayList;
 
 import org.apache.log4j.Logger;
 
-
-
 public class Viewer {
-    static final long serialVersionUID = 1;
-
-    private static Logger logger = Logger.getLogger(Viewer.class);
+
+    private static Logger LOGGER = Logger.getLogger(Viewer.class);
 
     Canvas3D canvas3d;
@@ -45,10 +40,6 @@
     private JCheckBoxMenuItem autorefreshItem;
 
-	private Connection connection;
-    ArrayList<String> args;
-
-    public Viewer(ArrayList<String> args, JMenuBar menuBar) {
+    public Viewer(JMenuBar menuBar) {
         super();
-        this.args = args;
         this.menuBar = menuBar;
         loggingItem = new JCheckBoxMenuItem("Logging");
@@ -56,5 +47,4 @@
 
         init();
-
     }
 
@@ -261,11 +251,4 @@
     }
 
-
-
-
-    public void setCommunication(Connection connection) {
-        this.connection = connection;
-    }
-
     public void rebuildViewMenu(Object creatures) {
 
